// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/parser/SceneItemComponentParser.hpp"
#include "util/CodeGen.hpp"

namespace Dawn {
  class SceneItemComponentGenerator : public CodeGen {
    public:
      static void generate(
        std::map<std::string, std::string> &assetMap,
        int32_t &componentNumber,
        std::vector<std::string> &includes,
        std::string itemRef,
        std::vector<std::string> *publicProperties,
        std::vector<std::string> *initBody,
        struct SceneItemComponent *component,
        std::string tabs
      );
  };
}